<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLApiTester&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classTIGLApiTester-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLApiTester&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__interface__engine.html">Interface</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Interface class for testing the different modules in the TIGL <br />
.  
 <a href="classTIGLApiTester.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglApiTester_8hpp_source.html">tiglApiTester.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for TIGLApiTester&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classTIGLApiTester.png" usemap="#TIGLApiTester&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;_map" alt=""/>
  <map id="TIGLApiTester&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;_map" name="TIGLApiTester&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;_map">
<area href="classTIGL.html" title="Top level class for the TIGL engine  . " alt="TIGL&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;" shape="rect" coords="0,0,343,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:abd94a03f393df87c989b5aca4e26c98f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abd94a03f393df87c989b5aca4e26c98f"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiTester.html#abd94a03f393df87c989b5aca4e26c98f">TIGLApiTester</a> (bool isDirected, uint64_t <a class="el" href="classTIGL.html#ac7f5c28d16a3566f413010d3e242167e">numTotalVertices</a>, uint_fast32_t idDevice=0, uint_fast32_t totalDevices=1, int allocThreads=NUM_OMP_THREADS)</td></tr>
<tr class="memdesc:abd94a03f393df87c989b5aca4e26c98f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor performs necessary memory release. <br /></td></tr>
<tr class="separator:abd94a03f393df87c989b5aca4e26c98f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a357fcce3cfa65b607b3f2bb9e94142f8"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiTester.html#a357fcce3cfa65b607b3f2bb9e94142f8">getVertex</a> (ID_TYPE id, ALG_VERTEX_TYPE *pVertex)</td></tr>
<tr class="memdesc:a357fcce3cfa65b607b3f2bb9e94142f8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieves a vertex.  <a href="#a357fcce3cfa65b607b3f2bb9e94142f8">More...</a><br /></td></tr>
<tr class="separator:a357fcce3cfa65b607b3f2bb9e94142f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a97fa334a3aa9c52e3aef64ea1849a519"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiTester.html#a97fa334a3aa9c52e3aef64ea1849a519">testMutationManagerModule</a> (char *fileName)</td></tr>
<tr class="memdesc:a97fa334a3aa9c52e3aef64ea1849a519"><td class="mdescLeft">&#160;</td><td class="mdescRight">Test procedure for mutation manager with single device.  <a href="#a97fa334a3aa9c52e3aef64ea1849a519">More...</a><br /></td></tr>
<tr class="separator:a97fa334a3aa9c52e3aef64ea1849a519"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c78bf9268bba7e3603466bc45bba2a9"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiTester.html#a5c78bf9268bba7e3603466bc45bba2a9">testMpiMutationManagerModule</a> (int_fast32_t readDev, char *fileName)</td></tr>
<tr class="memdesc:a5c78bf9268bba7e3603466bc45bba2a9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Test procedure for mutation manager with multiple devices.  <a href="#a5c78bf9268bba7e3603466bc45bba2a9">More...</a><br /></td></tr>
<tr class="separator:a5c78bf9268bba7e3603466bc45bba2a9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classTIGL"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classTIGL')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classTIGL.html">TIGL&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;</a></td></tr>
<tr class="memitem:a7a881a9ea2c7de238e2bc5cb05549bbb inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a7a881a9ea2c7de238e2bc5cb05549bbb">TIGL</a> (bool isDirected, uint64_t totalVertices, uint_fast32_t idDevice=0, uint_fast32_t totalDevices=1, int allocThreads=NUM_OMP_THREADS)</td></tr>
<tr class="memdesc:a7a881a9ea2c7de238e2bc5cb05549bbb inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor performs necessary memory allocations.  <a href="#a7a881a9ea2c7de238e2bc5cb05549bbb">More...</a><br /></td></tr>
<tr class="separator:a7a881a9ea2c7de238e2bc5cb05549bbb inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6d2aefc6fedb442ccbb2da4d862fd592 inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6d2aefc6fedb442ccbb2da4d862fd592"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a6d2aefc6fedb442ccbb2da4d862fd592">~TIGL</a> ()</td></tr>
<tr class="memdesc:a6d2aefc6fedb442ccbb2da4d862fd592 inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor performs necessary memory release. <br /></td></tr>
<tr class="separator:a6d2aefc6fedb442ccbb2da4d862fd592 inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6c1e8c5e4654394c45d764b4fcc65a87 inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6c1e8c5e4654394c45d764b4fcc65a87"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a6c1e8c5e4654394c45d764b4fcc65a87">reset</a> ()</td></tr>
<tr class="memdesc:a6c1e8c5e4654394c45d764b4fcc65a87 inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears the memory allocation for the graph. <br /></td></tr>
<tr class="separator:a6c1e8c5e4654394c45d764b4fcc65a87 inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70e3fc3f8dde6ef1c8bdbad2fba1f0bd inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a70e3fc3f8dde6ef1c8bdbad2fba1f0bd">networkReadGraph</a> (uint_fast32_t readDev, char *fileName=NULL)</td></tr>
<tr class="memdesc:a70e3fc3f8dde6ef1c8bdbad2fba1f0bd inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Newtwork reading subgraph from file.  <a href="#a70e3fc3f8dde6ef1c8bdbad2fba1f0bd">More...</a><br /></td></tr>
<tr class="separator:a70e3fc3f8dde6ef1c8bdbad2fba1f0bd inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeb111e5790f7118a8602e02ed7a574a9 inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#aeb111e5790f7118a8602e02ed7a574a9">mutateLocalSubgraphFromFile</a> (char *fileName)</td></tr>
<tr class="memdesc:aeb111e5790f7118a8602e02ed7a574a9 inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reads subgraph in the form of adjacency list.  <a href="#aeb111e5790f7118a8602e02ed7a574a9">More...</a><br /></td></tr>
<tr class="separator:aeb111e5790f7118a8602e02ed7a574a9 inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab8062bd5f494beded1afd864d055bcb9 inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#ab8062bd5f494beded1afd864d055bcb9">readSubgraphFromFile</a> (char *fileName)</td></tr>
<tr class="memdesc:ab8062bd5f494beded1afd864d055bcb9 inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reads subgraph in the form of adjacency list.  <a href="#ab8062bd5f494beded1afd864d055bcb9">More...</a><br /></td></tr>
<tr class="separator:ab8062bd5f494beded1afd864d055bcb9 inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9dfa4b01593d43a547c6e0750a4bf19d inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a9dfa4b01593d43a547c6e0750a4bf19d">initGraph</a> (vector&lt; ALG_VERTEX_TYPE &gt; &amp;vertexList)</td></tr>
<tr class="memdesc:a9dfa4b01593d43a547c6e0750a4bf19d inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a graph from a vertex list.  <a href="#a9dfa4b01593d43a547c6e0750a4bf19d">More...</a><br /></td></tr>
<tr class="separator:a9dfa4b01593d43a547c6e0750a4bf19d inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ab28bce4a032f285d88b973ab982053 inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a7ab28bce4a032f285d88b973ab982053">run</a> (uint_fast32_t maxSS=DEFAULT_MAXIMUM_SS, ALG_INIT *initParams=0)</td></tr>
<tr class="memdesc:a7ab28bce4a032f285d88b973ab982053 inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">The highest level function for TIGL engine execution.  <a href="#a7ab28bce4a032f285d88b973ab982053">More...</a><br /></td></tr>
<tr class="separator:a7ab28bce4a032f285d88b973ab982053 inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a302196e561a1518561bc2a6a2931a07c inherit pub_methods_classTIGL"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:a302196e561a1518561bc2a6a2931a07c inherit pub_methods_classTIGL"><td class="memTemplItemLeft" align="right" valign="top">double&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGL.html#a302196e561a1518561bc2a6a2931a07c">computeSNR</a> (vector&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt; &amp;refVect)</td></tr>
<tr class="memdesc:a302196e561a1518561bc2a6a2931a07c inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes the SNR (in dB) between the computed values and values from a benchmark implementation.  <a href="#a302196e561a1518561bc2a6a2931a07c">More...</a><br /></td></tr>
<tr class="separator:a302196e561a1518561bc2a6a2931a07c inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae83a1a4574743face7975d5df0a98f2d inherit pub_methods_classTIGL"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:ae83a1a4574743face7975d5df0a98f2d inherit pub_methods_classTIGL"><td class="memTemplItemLeft" align="right" valign="top">double&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGL.html#ae83a1a4574743face7975d5df0a98f2d">computeNormalizedSNR</a> (vector&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt; &amp;refVect)</td></tr>
<tr class="memdesc:ae83a1a4574743face7975d5df0a98f2d inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compares the output results with benchmark algorithm (similar to computeSNR but normalization takes place)  <a href="#ae83a1a4574743face7975d5df0a98f2d">More...</a><br /></td></tr>
<tr class="separator:ae83a1a4574743face7975d5df0a98f2d inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2a30c008f455e3588ed4a51669ecca8b inherit pub_methods_classTIGL"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:a2a30c008f455e3588ed4a51669ecca8b inherit pub_methods_classTIGL"><td class="memTemplItemLeft" align="right" valign="top">double&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGL.html#a2a30c008f455e3588ed4a51669ecca8b">computeMSE</a> (vector&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt; &amp;refVect)</td></tr>
<tr class="memdesc:a2a30c008f455e3588ed4a51669ecca8b inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes the Mean Square Error (MSE) between the computed value and a reference value.  <a href="#a2a30c008f455e3588ed4a51669ecca8b">More...</a><br /></td></tr>
<tr class="separator:a2a30c008f455e3588ed4a51669ecca8b inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c9a66bdfdacb4f33981b7a7c3c5cec8 inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5c9a66bdfdacb4f33981b7a7c3c5cec8"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a5c9a66bdfdacb4f33981b7a7c3c5cec8">memoryUsage</a> ()</td></tr>
<tr class="memdesc:a5c9a66bdfdacb4f33981b7a7c3c5cec8 inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes the approximate overall memory usage. <br /></td></tr>
<tr class="separator:a5c9a66bdfdacb4f33981b7a7c3c5cec8 inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7fecb3d90f1e6a080b174b82f44ff37 inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af7fecb3d90f1e6a080b174b82f44ff37"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#af7fecb3d90f1e6a080b174b82f44ff37">getNumVertices</a> ()</td></tr>
<tr class="memdesc:af7fecb3d90f1e6a080b174b82f44ff37 inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns number of local vertices. <br /></td></tr>
<tr class="separator:af7fecb3d90f1e6a080b174b82f44ff37 inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a338e3d1711c0e6fd442313c03deb97e5 inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a338e3d1711c0e6fd442313c03deb97e5"></a>
ID_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a338e3d1711c0e6fd442313c03deb97e5">getNumEdges</a> ()</td></tr>
<tr class="memdesc:a338e3d1711c0e6fd442313c03deb97e5 inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the total number of edges in the graph. <br /></td></tr>
<tr class="separator:a338e3d1711c0e6fd442313c03deb97e5 inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b572a77f00388592162ff8ffe408891 inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1b572a77f00388592162ff8ffe408891"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a1b572a77f00388592162ff8ffe408891">MaxCollision</a> ()</td></tr>
<tr class="memdesc:a1b572a77f00388592162ff8ffe408891 inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the maximum number of hash collisions in the position buffer. <br /></td></tr>
<tr class="separator:a1b572a77f00388592162ff8ffe408891 inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a788a7f3ca72fa79b55203763225eb393 inherit pub_methods_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a788a7f3ca72fa79b55203763225eb393"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a788a7f3ca72fa79b55203763225eb393">numSS</a> ()</td></tr>
<tr class="memdesc:a788a7f3ca72fa79b55203763225eb393 inherit pub_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of supersteps. <br /></td></tr>
<tr class="separator:a788a7f3ca72fa79b55203763225eb393 inherit pub_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classTIGL"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classTIGL')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classTIGL.html">TIGL&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;</a></td></tr>
<tr class="memitem:a9b1c21d26fd2410cc80c024924ffd2bf inherit pro_methods_classTIGL"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a9b1c21d26fd2410cc80c024924ffd2bf">mutateProcessOneLine</a> (string localLine, uint_fast32_t *numMessages)</td></tr>
<tr class="memdesc:a9b1c21d26fd2410cc80c024924ffd2bf inherit pro_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Processes a single line (in string format) of the graph file.  <a href="#a9b1c21d26fd2410cc80c024924ffd2bf">More...</a><br /></td></tr>
<tr class="separator:a9b1c21d26fd2410cc80c024924ffd2bf inherit pro_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a97db1aace1b818b2642ec093ef1567c0 inherit pro_methods_classTIGL"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a97db1aace1b818b2642ec093ef1567c0">mutateDistributedGraphFromFile</a> (char *fileName)</td></tr>
<tr class="memdesc:a97db1aace1b818b2642ec093ef1567c0 inherit pro_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructs a graph from a distributed file.  <a href="#a97db1aace1b818b2642ec093ef1567c0">More...</a><br /></td></tr>
<tr class="separator:a97db1aace1b818b2642ec093ef1567c0 inherit pro_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a10779a76581ed8a3a88e312eb800e0ba inherit pro_methods_classTIGL"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a10779a76581ed8a3a88e312eb800e0ba">remoteMutateDistributedGraph</a> (uint_fast32_t readDev)</td></tr>
<tr class="memdesc:a10779a76581ed8a3a88e312eb800e0ba inherit pro_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructs a graph from a distributed file.  <a href="#a10779a76581ed8a3a88e312eb800e0ba">More...</a><br /></td></tr>
<tr class="separator:a10779a76581ed8a3a88e312eb800e0ba inherit pro_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b1b79f24fc14b6acbdeb1aaff64d36b inherit pro_methods_classTIGL"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a3b1b79f24fc14b6acbdeb1aaff64d36b">computeTask</a> (uint_fast32_t maxSS, ALG_INIT *initParams)</td></tr>
<tr class="memdesc:a3b1b79f24fc14b6acbdeb1aaff64d36b inherit pro_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">The core computation task.  <a href="#a3b1b79f24fc14b6acbdeb1aaff64d36b">More...</a><br /></td></tr>
<tr class="separator:a3b1b79f24fc14b6acbdeb1aaff64d36b inherit pro_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a21583ccd06b1c3eb7115df8e9518353b inherit pro_methods_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a21583ccd06b1c3eb7115df8e9518353b"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a21583ccd06b1c3eb7115df8e9518353b">txTask</a> ()</td></tr>
<tr class="memdesc:a21583ccd06b1c3eb7115df8e9518353b inherit pro_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Starts the TX task that is handled by the communication manager. <br /></td></tr>
<tr class="separator:a21583ccd06b1c3eb7115df8e9518353b inherit pro_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa8910cce1cf6449d4119f32f79583a75 inherit pro_methods_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa8910cce1cf6449d4119f32f79583a75"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#aa8910cce1cf6449d4119f32f79583a75">rxTask</a> ()</td></tr>
<tr class="memdesc:aa8910cce1cf6449d4119f32f79583a75 inherit pro_methods_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">Starts the RX task that is handled by the communication manager. <br /></td></tr>
<tr class="separator:aa8910cce1cf6449d4119f32f79583a75 inherit pro_methods_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classTIGL"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classTIGL')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classTIGL.html">TIGL&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;</a></td></tr>
<tr class="memitem:a1928633793d2b130d62b93a6999fb415 inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1928633793d2b130d62b93a6999fb415"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a1928633793d2b130d62b93a6999fb415">rank</a></td></tr>
<tr class="memdesc:a1928633793d2b130d62b93a6999fb415 inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">ID of the current device. <br /></td></tr>
<tr class="separator:a1928633793d2b130d62b93a6999fb415 inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59fcdfd2bacee67418e182f347f898f7 inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a59fcdfd2bacee67418e182f347f898f7"></a>
<a class="el" href="classTIGLContainersSubgraph.html">SUBGRAPH_TYPE</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a59fcdfd2bacee67418e182f347f898f7">dataManager</a></td></tr>
<tr class="memdesc:a59fcdfd2bacee67418e182f347f898f7 inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to <a class="el" href="classTIGLContainersSubgraph.html" title="Graph container for each device in the TIGL. ">TIGLContainersSubgraph</a> object (allocated in the constructor) <br /></td></tr>
<tr class="separator:a59fcdfd2bacee67418e182f347f898f7 inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a350034bc25d3ef9fc5427c01eb51b280 inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a350034bc25d3ef9fc5427c01eb51b280"></a>
<a class="el" href="classTIGLCommunicationManager.html">COMMUNICATOR_TYPE</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a350034bc25d3ef9fc5427c01eb51b280">communicationManager</a></td></tr>
<tr class="memdesc:a350034bc25d3ef9fc5427c01eb51b280 inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to <a class="el" href="classTIGLCommunicationManager.html" title="Core communicator class definition. ">TIGLCommunicationManager</a> object (allocated in the constructor) <br /></td></tr>
<tr class="separator:a350034bc25d3ef9fc5427c01eb51b280 inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a38c56842f9838f3c58f7fd15fc6c6bf7 inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a38c56842f9838f3c58f7fd15fc6c6bf7"></a>
<a class="el" href="classTIGLComputationManager.html">COMPUTATION_TYPE</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a38c56842f9838f3c58f7fd15fc6c6bf7">computationManager</a></td></tr>
<tr class="memdesc:a38c56842f9838f3c58f7fd15fc6c6bf7 inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to <a class="el" href="classTIGLComputationManager.html" title="Core Computation class for the TIGL. ">TIGLComputationManager</a> object (allocated in the constructor) <br /></td></tr>
<tr class="separator:a38c56842f9838f3c58f7fd15fc6c6bf7 inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5541f512541b62a53b718520ba942625 inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5541f512541b62a53b718520ba942625"></a>
ALG_COMBINER *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a5541f512541b62a53b718520ba942625">combiner</a></td></tr>
<tr class="memdesc:a5541f512541b62a53b718520ba942625 inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to user-defined combiner object (allocated in the constructor) <br /></td></tr>
<tr class="separator:a5541f512541b62a53b718520ba942625 inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd9412890896557621ab288764a83f44 inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acd9412890896557621ab288764a83f44"></a>
<a class="el" href="classTIGLMutationManager.html">MUTATION_TYPE</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#acd9412890896557621ab288764a83f44">mutationManager</a></td></tr>
<tr class="memdesc:acd9412890896557621ab288764a83f44 inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to <a class="el" href="classTIGLMutationManager.html" title="Mutation manager class. ">TIGLMutationManager</a> object (allocated in the constructor) <br /></td></tr>
<tr class="separator:acd9412890896557621ab288764a83f44 inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:affa2deafa252a76aabf16e1b52c5992d inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="affa2deafa252a76aabf16e1b52c5992d"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#affa2deafa252a76aabf16e1b52c5992d">numDevices</a></td></tr>
<tr class="memdesc:affa2deafa252a76aabf16e1b52c5992d inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of devices (1 if MPI is not used) <br /></td></tr>
<tr class="separator:affa2deafa252a76aabf16e1b52c5992d inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff8f26ab7c900ed74baa523afc72f369 inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aff8f26ab7c900ed74baa523afc72f369"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#aff8f26ab7c900ed74baa523afc72f369">numLocalVertices</a></td></tr>
<tr class="memdesc:aff8f26ab7c900ed74baa523afc72f369 inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">number of local vertices <br /></td></tr>
<tr class="separator:aff8f26ab7c900ed74baa523afc72f369 inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac7f5c28d16a3566f413010d3e242167e inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac7f5c28d16a3566f413010d3e242167e"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#ac7f5c28d16a3566f413010d3e242167e">numTotalVertices</a></td></tr>
<tr class="memdesc:ac7f5c28d16a3566f413010d3e242167e inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of vertices in the graph <br /></td></tr>
<tr class="separator:ac7f5c28d16a3566f413010d3e242167e inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb3c1874d24580f08b4794d7b3e1fd8b inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abb3c1874d24580f08b4794d7b3e1fd8b"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#abb3c1874d24580f08b4794d7b3e1fd8b">flagDirected</a></td></tr>
<tr class="memdesc:abb3c1874d24580f08b4794d7b3e1fd8b inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">directed/undirected graph <br /></td></tr>
<tr class="separator:abb3c1874d24580f08b4794d7b3e1fd8b inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64fdb2311577f9179f9180124336e6fd inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a64fdb2311577f9179f9180124336e6fd"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#a64fdb2311577f9179f9180124336e6fd">algorithmRunning</a></td></tr>
<tr class="memdesc:a64fdb2311577f9179f9180124336e6fd inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">true if the algorithm is running, otherwise false <br /></td></tr>
<tr class="separator:a64fdb2311577f9179f9180124336e6fd inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef38bee1457371fb710a3146bff6fc6f inherit pro_attribs_classTIGL"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aef38bee1457371fb710a3146bff6fc6f"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGL.html#aef38bee1457371fb710a3146bff6fc6f">countSS</a></td></tr>
<tr class="memdesc:aef38bee1457371fb710a3146bff6fc6f inherit pro_attribs_classTIGL"><td class="mdescLeft">&#160;</td><td class="mdescRight">the superstep counter <br /></td></tr>
<tr class="separator:aef38bee1457371fb710a3146bff6fc6f inherit pro_attribs_classTIGL"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename ALG_VERTEX_TYPE, typename ALG_COMBINER&gt;<br />
class TIGLApiTester&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;</h3>

<p>Interface class for testing the different modules in the TIGL <br />
. </p>
<p>It inherits the core interface class tigl, and adds special procedures for modules testing </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a357fcce3cfa65b607b3f2bb9e94142f8"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_VERTEX_TYPE , typename ALG_COMBINER &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLApiTester.html">TIGLApiTester</a>&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;::getVertex </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ALG_VERTEX_TYPE *&#160;</td>
          <td class="paramname"><em>pVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Retrieves a vertex. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>the ID of the requested vertex </td></tr>
    <tr><td class="paramname">pVertex</td><td>pointer to the vertex object to which the vertex is retrieved </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the vertex exists, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a5c78bf9268bba7e3603466bc45bba2a9"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_VERTEX_TYPE , typename ALG_COMBINER &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLApiTester.html">TIGLApiTester</a>&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;::testMpiMutationManagerModule </td>
          <td>(</td>
          <td class="paramtype">int_fast32_t&#160;</td>
          <td class="paramname"><em>readDev</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>fileName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Test procedure for mutation manager with multiple devices. </p>
<p>It processes basic mutation messages and compares the output with reference implementation </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">fileName</td><td>the name of the file that contains the adjacency list of the graph </td></tr>
    <tr><td class="paramname">readDev</td><td>the rank of the device that reads the graph from its file system </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if success, otherwise false </dd></dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Read the graph file using <a class="el" href="">networkReadGraph </a></li>
<li>Read the graph file plainly to construct simple adjacency list</li>
<li>Check the graph consistency by comparing the local subgrah to the corresponding subgraph of the reference grahp </li>
</ol>

</div>
</div>
<a class="anchor" id="a97fa334a3aa9c52e3aef64ea1849a519"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_VERTEX_TYPE , typename ALG_COMBINER &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLApiTester.html">TIGLApiTester</a>&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;::testMutationManagerModule </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>fileName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Test procedure for mutation manager with single device. </p>
<p>It processes basic mutation messages and compares the output with reference implementation </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">fileName</td><td>the name of the file that contains the adjacency list of the graph </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if success, otherwise false </dd></dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Read the graph file using <a class="el" href="">mutateLocalSubgraphFromFile </a></li>
<li>Read the graph file plainly to construct simple adjacency list</li>
<li>Check the vertex consistency</li>
<li>Remove selected vertices and edges and recheck consistency</li>
<li>Add back the removed vertices and edges and recheck consistency </li>
</ol>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="tiglApiTester_8hpp_source.html">tiglApiTester.hpp</a></li>
<li><a class="el" href="tiglImplementationTester_8hpp_source.html">tiglImplementationTester.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:56 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
